/*
 * Copyright 2008- kensir0u.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
/*
 * 쐬       F2008/11/05
 * pbP[W   Fikdnet.dijava
 * t@C   FToken.java
 */
package ikdnet.dijava;

/**
 * <i>Tv</i>F g[NێNX@.
 * <p>
 * g[NێNXB
 * 
 * 
 * @author kensir0u
 * @version 1.0
 * @since JDK 5.0
 * 
 */
public class Token {

	/**
	 * <i>Tv</i>F g[N킷NX
	 * .<p>
	 * g[N킷NX
	 *
	 */
	private Class<?> clazz;
	/**
	 * <i>Tv</i>F g[N^Cv
	 * .<p>
	 * g[N^Cv
	 *
	 */
	private TokenType type;
	/**
	 * <i>Tv</i>F g[No[
	 * .<p>
	 * g[No[
	 *
	 */
	private Object value;
	/**
	 * <i>Tv</i>F 
	 * .<p>
	 * 
	 *
	 */
	private String sentence;

	/**
	 * 
	 * <i>Tv</i>F ̐ݒ .
	 * <p>
	 * ݒ肷B @
	 * 
	 * @param sentence
	 */
	public Token(final String sentence) {
		this.sentence = sentence;
	}

	/**
	 * 
	 * <i>Tv</i>F ̐ݒƒl̐ݒ .
	 * <p>
	 * ̐ݒƒl̐ݒsB @
	 * 
	 * @param sentence
	 * @param value
	 */
	public Token(final String sentence, final Object value) {
		this.sentence = sentence;
		this.value = value;
	}

	/**
	 * 
	 * <i>Tv</i>F ƒlƃg[N^Cv̐ݒ .
	 * <p>
	 * ƒlƃg[N^Cv̐ݒ @
	 * 
	 * @param sentence
	 * @param value
	 * @param type
	 */
	public Token(final String sentence, final Object value, final TokenType type) {
		this.sentence = sentence;
		this.value = value;
		this.type = type;
	}

	/**
	 * 
	 * <i>Tv</i>F ƒlƃg[N^CvƃNX̐ݒ .
	 * <p>
	 * ƒlƃg[N^CvƃNX̐ݒsB @
	 * 
	 * @param sentence
	 * @param value
	 * @param type
	 * @param clazz
	 */
	public Token(final String sentence, final Object value, final TokenType type, final Class<?> clazz) {
		this.sentence = sentence;
		this.value = value;
		this.type = type;
		this.clazz = clazz;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.Token#clazz}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.Token#clazz}ԋpB @
	 * 
	 * @return the clazz
	 */
	public Class<?> getClazz() {
		return clazz;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.Token#clazz}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.Token#clazz}ݒ肷B
	 * 
	 * @param clazz
	 *            the clazz to set
	 */
	public void setClazz(final Class<?> clazz) {
		this.clazz = clazz;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.Token#type}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.Token#type}ԋpB @
	 * 
	 * @return the type
	 */
	public TokenType getType() {
		return type;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.Token#type}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.Token#type}ݒ肷B
	 * 
	 * @param type
	 *            the type to set
	 */
	public void setType(final TokenType type) {
		this.type = type;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.Token#value}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.Token#value}ԋpB @
	 * 
	 * @return the value
	 */
	public Object getValue() {
		return value;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.Token#value}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.Token#value}ݒ肷B
	 * 
	 * @param value
	 *            the value to set
	 */
	public void setValue(final Object value) {
		this.value = value;
	}

	/**
	 * <i>Tv</i>F {@link ikdnet.dijava.Token#sentence}̕ԋp .
	 * <p>
	 * {@link ikdnet.dijava.Token#sentence}ԋpB @
	 * 
	 * @return the sentence
	 */
	public String getSentence() {
		return sentence;
	}

	/**
	 * <i>Tv</i>F{@link ikdnet.dijava.Token#sentence}ݒ .
	 * <p>
	 * {@link ikdnet.dijava.Token#sentence}ݒ肷B
	 * 
	 * @param sentence
	 *            the sentence to set
	 */
	public void setSentence(final String sentence) {
		this.sentence = sentence;
	}

}
